#include <bits/stdc++.h>

using namespace std;

const int Inf = 1000000000;

vector<int> t;
vector<int> add;

void _build(int root, int tleft, int tright, const vector<int> &a) {
  if (tleft == tright) {
    t[root] = a[tleft];
  } else {
    int mid = (tleft + tright) / 2;
    _build(root * 2 + 1, tleft, mid, a);
    _build(root * 2 + 2, mid + 1, tright, a);
    t[root] = max(t[root * 2 + 1], t[root * 2 + 2]);
  }
}

void build(const vector<int> &a) {
  t.assign(4 * a.size(), -Inf);
  add.assign(4 * a.size(), 0);
  _build(0, 0, a.size() - 1, a);
}

void push(int root, int tleft, int tright) {
  if (add[root] != 0 && tleft < tright) {
    add[root * 2 + 1] += add[root];
    add[root * 2 + 2] += add[root];        
    add[root] = 0;
    t[root] = max(t[root * 2 + 1] + add[root * 2 + 1], t[root * 2 + 2] + add[root * 2 + 2]);
  }
}

void _update(int root, int tleft, int tright, int pos, int newVal) {
  if (tleft == tright) {
    assert(tleft == pos);
    t[root] = newVal;
    add[root] = 0;
  } else {
    push(root, tleft, tright);
    int mid = (tleft + tright) / 2;
    if (pos <= mid)
      _update(root * 2 + 1, tleft, mid, pos, newVal);
    else
      _update(root * 2 + 2, mid + 1, tright, pos, newVal);
    t[root] = max(t[root * 2 + 1] + add[root * 2 + 1], t[root * 2 + 2] + add[root * 2 + 2]);
  }
}

void update(int pos, int newVal) {
  _update(0, 0, t.size() / 4 - 1, pos, newVal);
}

int _getMax(int root, int tleft, int tright, int sleft, int sright) {
  if (tleft >= sleft && tright <= sright) {
    return t[root] + add[root];
  }
  assert(tleft < tright);
  int mid = (tleft + tright) / 2;
  int ans = -Inf;
  push(root, tleft, tright);
  if (sleft <= mid) {
    ans = max(ans, _getMax(root * 2 + 1, tleft, mid, sleft, sright));
  }
  if (sright > mid) {
    ans = max(ans, _getMax(root * 2 + 2, mid + 1, tright, sleft, sright));
  }
  return ans;
}

int getMax(int sleft, int sright) {
  return _getMax(0, 0, t.size() / 4 - 1, sleft, sright);
}

void _addToSeg(int root, int tleft, int tright, int sleft, int sright, int val) {
  if (tleft >= sleft && tright <= sright) {
    add[root] += val;
    return;
  }
  assert(tleft < tright);
  int mid = (tleft + tright) / 2;
  push(root, tleft, tright);
  if (sleft <= mid) {
    _addToSeg(root * 2 + 1, tleft, mid, sleft, sright, val);
  }
  if (sright > mid) {
    _addToSeg(root * 2 + 2, mid + 1, tright, sleft, sright, val);  
  }
  t[root] = max(t[root * 2 + 1] + add[root * 2 + 1], t[root * 2 + 2] + add[root * 2 + 2]);
}

void addToSeg(int sleft, int sright, int val) {
  _addToSeg(0, 0, t.size() / 4 - 1, sleft, sright, val);
}

int main() {
  vector<int> a = {3, 2, 5, 6, 4};
  build(a);
  cout << getMax(0, 2) << "\n";
  cout << getMax(1, 3) << "\n";
  cout << getMax(1, 4) << "\n";
  //update(3, 2);
  addToSeg(0, 2, 3);
  cout << getMax(0, 2) << "\n";
  cout << getMax(1, 3) << "\n";
  cout << getMax(1, 4) << "\n";
  cout << getMax(3, 4) << "\n";
}
