#include<bits/stdc++.h>
using namespace std;

const int Inf = 1000000001;

vector<int> t;

void _update(int root, int tleft, int tright, int pos, int newVal) {
  if (tleft == tright) {
    assert(tleft == pos);
    t[root] = newVal;
  } else {
    int mid = (tleft + tright) / 2;
    if (pos <= mid)
      _update(root * 2 + 1, tleft, mid, pos, newVal);
    else
      _update(root * 2 + 2, mid + 1, tright, pos, newVal);
    t[root] = max(t[root * 2 + 1], t[root * 2 + 2]);
  }
}

void update(int pos, int newVal) {
  _update(0, 0, t.size() / 4 - 1, pos, newVal);
}

int _getMax(int root, int tleft, int tright, int sleft, int sright) {
  if (tleft >= sleft && tright <= sright) {
    return t[root];
  }
  assert(tleft < tright);
  int mid = (tleft + tright) / 2;
  int ans = -Inf;
  if (sleft <= mid) {
    ans = max(ans, _getMax(root * 2 + 1, tleft, mid, sleft, sright));
  }
  if (sright > mid) {
    ans = max(ans, _getMax(root * 2 + 2, mid + 1, tright, sleft, sright));
  }
  return ans;
}

int getMax(int sleft, int sright) {
  return _getMax(0, 0, t.size() / 4 - 1, sleft, sright);
}


vector<int> lnds(vector<int> &a) {
  int n = (int)a.size();
  vector<int> aa = a;
  sort(aa.begin(), aa.end());
  aa.erase(unique(aa.begin(), aa.end()), aa.end());
  for (int &x : a) {
    x = lower_bound(aa.begin(), aa.end(), x) - aa.begin();
  }
  t.assign(n * 4, -Inf);
  vector<int> res(n);
  for (int i = 0; i < n; i++) {
    res[i] = max(1, 1 + getMax(0, a[i]));
    update(a[i], res[i]);
  }
  for (int i = 1; i < n; i++)
    res[i] = max(res[i], res[i - 1]);
  return res;
}

int main() {
  int n;
  std::cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++)
    cin >> a[i];
  vector<int> len_left = lnds(a);
  reverse(a.begin(), a.end());
  for (int &x : a)
    x = -x;
  vector<int> len_right = lnds(a);
  reverse(len_right.begin(), len_right.end());
  int max_len = len_left[n - 1];
  for (int i = 0; i < n - 1; i++)
    max_len = max(max_len, len_left[i] + len_right[i + 1]);
  cout << max_len;
}
